#
# (c) 2025, Yegor Yakubovich, yegoryakubovich.com, personal@yegoryakybovich.com
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#


from nexium_api import route

from yagroup_pay.shared import ParseRateSourceRequestData, ParseRateSourceResponseData, GetValuesRateSourceRequestData, \
    GetValuesRateSourceResponseData
from .base import Router


class RateSourceRouter(Router):
    facade_service = 'RateSourceFacadeService'
    prefix = '/rates-source'

    @route(
        path='/parse',
        request_data=ParseRateSourceRequestData,
        response_data=ParseRateSourceResponseData,
        response_field='values',
    )
    async def parse(self):
        pass

    @route(
        path='/get-values',
        request_data=GetValuesRateSourceRequestData,
        response_data=GetValuesRateSourceResponseData,
        response_field='values',
    )
    async def get_values(self):
        pass
